// Detect It Easy Plugin for CFF Explorer
// Plugin Version: 1.1
// Plugin Author: exet0l
// Detect It Easy Authors: Hellsp@wn, Hors

#include <windows.h>
#include "CFFExplorerSDK.h"
#include "resource.h"

UINT nCFFApiMask[] =
{
    m_eaGetObjectAddress,
    m_eaGetObjectSize,
    m_eaObjectChanged,
    m_eaReplaceObject,
    m_eaFreeObject,
    m_eaGetObjectName,
    m_eaSaveObject,

    m_eaIsPE64,
    m_eaIsRvaValid,
    m_eaRvaToOffset,
    m_eaVaToRva,
    m_eaVaToRva64,
    m_eaVaToOffset,
    m_eaVaToOffset64,
    m_eaOffsetToRva,
    m_eaSectionFromRva,
    m_eaEntryPoint,
    m_eaGetDataDirectory,
    m_eaAddSectionHeader,
    m_eaAddSection,
    m_eaDeleteSectionHeader,
    m_eaDeleteSection,
    m_eaAddDataToLastSection,
    m_eaRebuildImageSize,
    m_eaRebuildPEHeader,
    m_eaRealignPE,
    m_eaRemoveRelocSection,
    m_eaBindImports,
    m_eaRemoveStrongNameSignature,
    m_eaSetImageBase,
    m_eaAfterDumpHeaderFix,

    0
};

typedef struct _CFFAPI
{
    d_eaGetObjectAddress eaGetObjectAddress;
    d_eaGetObjectSize eaGetObjectSize;
    d_eaObjectChanged eaObjectChanged;
    d_eaReplaceObject eaReplaceObject;
    d_eaFreeObject eaFreeObject;
    d_eaGetObjectName eaGetObjectName;
    d_eaSaveObject eaSaveObject;

    d_eaIsPE64 eaIsPE64;
    d_eaIsRvaValid eaIsRvaValid;
    d_eaRvaToOffset eaRvaToOffset;
    d_eaVaToRva eaVaToRva;
    d_eaVaToRva64 eaVaToRva64;
    d_eaVaToOffset eaVaToOffset;
    d_eaVaToOffset64 eaVaToOffset64;
    d_eaOffsetToRva eaOffsetToRva;
    d_eaSectionFromRva eaSectionFromRva;
    d_eaEntryPoint eaEntryPoint;
    d_eaGetDataDirectory eaGetDataDirectory;
    d_eaAddSectionHeader eaAddSectionHeader;
    d_eaAddSection eaAddSection;
    d_eaDeleteSectionHeader eaDeleteSectionHeader;
    d_eaDeleteSection eaDeleteSection;
    d_eaAddDataToLastSection eaAddDataToLastSection;
    d_eaRebuildImageSize eaRebuildImageSize;
    d_eaRebuildPEHeader eaRebuildPEHeader;
    d_eaRealignPE eaRealignPE;
    d_eaRemoveRelocSection eaRemoveRelocSection;
    d_eaBindImports eaBindImports;
    d_eaRemoveStrongNameSignature eaRemoveStrongNameSignature;
    d_eaSetImageBase eaSetImageBase;
    d_eaAfterDumpHeaderFix eaAfterDumpHeaderFix;

} CFFAPI, *PCFFAPI;

CFFAPI g_cffAPI;

LRESULT CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

HMODULE GetCurrentModuleHandle()
{
    HMODULE hModule;
    GetModuleHandleEx(GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS | GET_MODULE_HANDLE_EX_FLAG_UNCHANGED_REFCOUNT,
                      (LPCWSTR)&GetCurrentModuleHandle, &hModule);
    return hModule;
}

void ExtractFilePath(wchar_t *fileName)
{
    int len = lstrlen(fileName);

    for(int i = len - 1; i > 0; i--)
    {
        if(fileName[i] == L'\\')
        {
            fileName[i + 1] = 0;
            break;
        }
    }
}

const int BUFSIZE = 4096;
bool ReadFromDIE(wchar_t *cmdLine, char buffer[BUFSIZE])
{
    HANDLE hReadPipe;
    HANDLE hWritePipe;

    SECURITY_ATTRIBUTES sa;
    sa.nLength = sizeof(sa);
    sa.bInheritHandle = TRUE;
    sa.lpSecurityDescriptor = nullptr;

    if(!CreatePipe(&hReadPipe, &hWritePipe, &sa, 0))
    {
        return false;
    }

    STARTUPINFO si;
    ZeroMemory(&si, sizeof(si));
    si.dwFlags |= STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
    si.wShowWindow = SW_HIDE;
    si.hStdOutput = hWritePipe;
    si.hStdError = hWritePipe;

    PROCESS_INFORMATION pi;
    ZeroMemory(&pi, sizeof(pi));

    if(!CreateProcess(nullptr, cmdLine, nullptr, nullptr, TRUE, CREATE_NEW_CONSOLE, nullptr, nullptr, &si, &pi))
    {
        CloseHandle(hReadPipe);
        CloseHandle(hWritePipe);
        return false;
    }

    WaitForSingleObject(pi.hProcess, 3000);

    ZeroMemory(&buffer[0], BUFSIZE);

    DWORD br;
    ReadFile(hReadPipe, &buffer[0], BUFSIZE, &br, nullptr);

    CloseHandle(pi.hThread);
    CloseHandle(pi.hProcess);
    CloseHandle(hReadPipe);
    CloseHandle(hWritePipe);

    return true;
}

BOOL APIENTRY DllEntryPoint(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    return TRUE;
}

extern "C" __declspec(dllexport) BOOL __cdecl ExtensionLoad(EXTINITDATA *pExtInitData)
{
    pExtInitData->RetrieveExtensionApi(nCFFApiMask, &g_cffAPI);

    VOID **ppApi = (VOID **)&g_cffAPI;

    for(UINT x = 0; ; x++)
    {
        if(nCFFApiMask[x] == 0)
        {
            break;
        }

        if(!ppApi[x])
        {
            return FALSE;
        }
    }

    return TRUE;
}

extern "C" __declspec(dllexport) VOID __cdecl ExtensionUnload()
{
}

extern "C" __declspec(dllexport) WCHAR * __cdecl ExtensionName()
{
    return L"Detect It Easy";
}

extern "C" __declspec(dllexport) WCHAR * __cdecl ExtensionDescription()
{
    return L"Detect It Easy";
}

extern "C" __declspec(dllexport) BOOL __cdecl ExtensionNeeded(VOID *pObject, UINT uSize)
{
    return TRUE;
}

extern "C" __declspec(dllexport) VOID *  __cdecl ExtensionExecute(LPARAM lParam)
{
    static EXTEVENTSDATA eed;
    eed.cbSize = sizeof(eed);
    eed.hInstance = GetCurrentModuleHandle();
    eed.DlgID = IDD_MAINDIALOG;
    eed.DlgProc = DlgProc;

    return &eed;
}

LRESULT CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
        case WM_INITDIALOG:
            wchar_t tmp[MAX_PATH];
            wchar_t cmdLine[MAX_PATH * 3];
            char buffer[BUFSIZE];

            GetModuleFileName(GetCurrentModuleHandle(), tmp, MAX_PATH);
            ExtractFilePath(tmp);

            lstrcpy(cmdLine, tmp);
            lstrcat(cmdLine, L"die\\diec.exe");

            g_cffAPI.eaGetObjectName(hDlg, tmp);

            lstrcat(cmdLine, L" \"");
            lstrcat(cmdLine, tmp);
            lstrcat(cmdLine, L"\"");
            lstrcat(cmdLine, L" -showerrors:no");
            lstrcat(cmdLine, L" -showentropy:yes");

            if(ReadFromDIE(cmdLine, buffer))
            {
                SetDlgItemTextA(hDlg, IDC_EDT_RESULT, buffer);
            }
            else
            {
                SetDlgItemTextA(hDlg, IDC_EDT_RESULT, "Error: Unable read from DIE");
            }

            return TRUE;

        case WM_SIZE:
            RECT rc;
            GetClientRect(hDlg, &rc);

            MoveWindow(GetDlgItem(hDlg, IDC_GB_RESULT), rc.left + 10, rc.top + 10, rc.right - 20, rc.bottom - 20, TRUE);
            MoveWindow(GetDlgItem(hDlg, IDC_EDT_RESULT), rc.left + 20, rc.top + 30, rc.right - 40, rc.bottom - 50, TRUE);
            break;

    }

    return FALSE;
}
